# Visualization Library A lightweight C++ OpenGL middleware for 2D/3D graphics | [Home] [Tutorials] [All Classes] [Grouped Classes]

# vl::SceneManagerBVH< T > Class Template Reference

The SceneManagerBVH class implements the basic functionalities for bounding-volume-hierarchy based scene managers. More...

`#include <SceneManagerBVH.hpp>`

Inheritance diagram for vl::SceneManagerBVH< T >:

List of all members.

## Public Member Functions
virtual const char * | className ()
| Returns the name of the class.
void | setTree (T *bbh)
| Sets the tree to be used by the scene manager.
const T * | tree () const
| Returns the tree used by the scene manager.
T * | tree ()
| Returns the tree used by the scene manager.
virtual void | appendVisibleActors (ActorCollection &list, const Camera *camera)
| Performs frustum culling and appends the enabled and visible Actor[s] to the given ActorCollection.
virtual void | appendActors (ActorCollection &list)
| Appends all the Actor[s] contained in the scene manager without performing frustum culling or checking enable masks.
## Protected Attributes
ref< T > | mBoundingVolumeTree

## Detailed Description

### template<class T>
class vl::SceneManagerBVH< T >

The SceneManagerBVH class implements the basic functionalities for bounding-volume-hierarchy based scene managers.

See also:
  - Actor
  - ActorKdTree
  - ActorTree
  - SceneManager
  - SceneManagerActorKdTree
  - SceneManagerActorTree
  - SceneManagerPortals

## Member Function Documentation

template<class T>

virtual const char* vl::SceneManagerBVH< T >::className | ( |  | ) | `[inline, virtual]`

Returns the name of the class.

Reimplemented from vl::SceneManager.

Reimplemented in vl::SceneManagerActorKdTree, vl::SceneManagerActorTree, and vl::Terrain.

template<class T>

void vl::SceneManagerBVH< T >::setTree | ( | T * | bbh | ) | `[inline]`

Sets the tree to be used by the scene manager.

template<class T>

const T* vl::SceneManagerBVH< T >::tree | ( |  | ) | const`[inline]`

Returns the tree used by the scene manager.

template<class T>

T* vl::SceneManagerBVH< T >::tree | ( |  | ) | `[inline]`

Returns the tree used by the scene manager.

template<class T>

virtual void vl::SceneManagerBVH< T >::appendVisibleActors | ( | ActorCollection & | list,
|  | const Camera * | camera |
| ) |  |  | `[inline, virtual]`

Performs frustum culling and appends the enabled and visible Actor[s] to the given ActorCollection.

See also enableMask(), Actor::enableMask()

Implements vl::SceneManager.

template<class T>

virtual void vl::SceneManagerBVH< T >::appendActors | ( | ActorCollection & | list | ) | `[inline, virtual]`

Appends all the Actor[s] contained in the scene manager without performing frustum culling or checking enable masks.

Implements vl::SceneManager.

## Member Data Documentation

template<class T>

ref<T> vl::SceneManagerBVH< T >::mBoundingVolumeTree`[protected]`

The documentation for this class was generated from the following file:

- E:/VisualizationLibrary/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vl/SceneManagerBVH.hpp

Visualization Library v2009.08 Reference Documentation
Copyright 2005-2009 Michele Bosi. All rights reserved.
Updated on Sun Nov 29 11:11:50 2009.
Permission is granted to use this page to write and publish articles regarding Visualization Library.